#ifndef __LCD_H__
#define __LCD_H__


#define ICON_ANT	0
#define ICON_BAT	1
#define ICON_SCSI	2

#define LCD_POS(r,c)	(0x80 | (r*0x40 + c))
#define LCD_LINE(x)	lcd_cmd(LCD_POS(x,0))

void lcd_cmd(unsigned char);
void lcd_init(void);
void lcd_putc(char);
void lcd_puts(const char *);
void lcd_clear(void);
void lcd_puticon(unsigned char icon, unsigned char value);

#define DEBUG_PRINT(x)	{ \
LCD_LINE(0); \
tiny_printf(lcd_putc, "%s", x); \
}


#endif // __LCD_H__
